﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            Session["data"] = MakeTable();
            HiddenSorting.Value = "0";
        }
        else
        {
            string str = Page.Request.Params["__EVENTTARGET"];
            if (str.StartsWith("WebDataGrid1"))
            {
                string column = str.Substring(13);

            }
        }
        WebDataGrid1.DataSource = Session["data"];
    }
    
    protected void WebDataGrid1_ColumnSorted(object sender, Infragistics.Web.UI.GridControls.SortingEventArgs e)
    {
        if (e.Column.Key == "Template")
        {
            e.SortedColumns.Clear();
            if (HiddenSorting.Value == "1")
            {
                e.SortedColumns.Add(WebDataGrid1.Columns["Data"], Infragistics.Web.UI.SortDirection.Ascending);
            }
            else
            {
                e.SortedColumns.Add(WebDataGrid1.Columns["Data"], Infragistics.Web.UI.SortDirection.Descending);

            }
        }
    }

    #region "Data"
    private DataTable MakeTable()
    {
        // Create a new DataTable.
        System.Data.DataTable table = new DataTable("Table");
        // Declare variables for DataColumn and DataRow objects.
        DataColumn column;
        DataRow row;

        // Create new DataColumn, set DataType, 
        // ColumnName and add to DataTable.    
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        // Add the Column to the DataColumnCollection.
        table.Columns.Add(column);

        // Create third column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);


        // Create Fourth column.
        column = new DataColumn();        
        column.DataType = System.Type.GetType("System.Decimal");
        column.ColumnName = "QtyPurhased";
        column.AutoIncrement = false;
        column.Caption = "Quanity Purchased";
        column.ReadOnly = false;
        column.Unique = false;        
        // Add the column to the table.
        table.Columns.Add(column);

        // Create fifth column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Decimal");
        column.ColumnName = "Price";
        column.AutoIncrement = false;
        column.Caption = "Priced";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);


        column = new DataColumn();
        column.ColumnName = "LinkText";
        table.Columns.Add("LinkText");




        // Make the ID column the primary key column.
        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["id"];
        table.PrimaryKey = PrimaryKeyColumns;


        Random rnd = new Random();
        for (int i = 0; i <= 20; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Data"] = "Data " + rnd.Next(1, 1000);
            row["QtyPurhased"] = i * 5.5;
            row["Price"] = i * ((100 * 4) / .05);
            row.SetField<string>("LinkText", "LinkText" + i);
            table.Rows.Add(row);
        }
        return table;
    }
    #endregion


    protected void WebDataGrid1_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
    {
        decimal unitsOnOrder = (decimal)e.Row.Items.FindItemByKey("QtyPurhased").Value;            
        
        decimal pricePerUnit = (decimal)e.Row.Items.FindItemByKey("Price").Value;
        var total = e.Row.Items.FindItemByKey("Total").Value = decimal.Multiply(unitsOnOrder, pricePerUnit);

        // inject link html in the unbound column and get the link text from the hidden bound column 
        e.Row.Items.FindItemByKey("Link").Value = " <a href=\"somePage.aspx\" >" + e.Row.Items.FindItemByKey("LinkText").Value + "  </a>";
    }
}